#include <stdio.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include "Lom.h"
#include "Render.h"

/*
 *	Draw a font symbol.
 */
 
 
void DrawLetter(GtkWidget *w, int x, int y, int letter, int ink, int paper, unsigned char *font, int invert)
{
	GdkDrawable *target = w->window;
	int yp, xp;
	unsigned char *dp=&font[letter*8];
	unsigned char dv;
	
	if(invert==0xFF)
	{
		int t=ink;
		ink=paper;
		paper=t;
		invert=0;
	}
		
	if(paper!=-1)
	{
		gdk_draw_rectangle(target, Colours[paper], 1, x,y , 16, 16);
	}
	for(yp=0;yp<8; yp++)
	{
		dv=*dp++;
		dv^=invert;
		
		for(xp=0;xp<8;xp++)
		{
			if(dv&128)
			{
				gdk_draw_rectangle(target, Colours[ink], 1,
					x+2*xp, y+2*yp,
					2,2);
			}
			dv<<=1;
		}
	}
}

void DrawShieldElement(GtkWidget *w, int shield, int x, int y, int ink, int paper)
{
	struct shield_block *sb=&ShieldBlock[shield];
	int xd, yd;
	
	unsigned char *bp=sb->data;

	for(yd=0; yd < sb->depth; yd++)
	{
		for(xd=0; xd < sb->width; xd++)
		{
			if(*bp!=0)
			{
				DrawLetter(w, x+16*xd, y+16*yd, *bp, paper, ink, ShieldTable, 0);
			}
			bp++;
		}
	}
}
	
				
void DrawShield(GtkWidget *w, int shield)
{
	unsigned char *x=ShieldBuild+shield*8;
	int paper = *x;
	int ink = 1;
	int element=0;
	int row=0, col=0;
	int offset = 0x190;
	
	while(1)
	{
		DrawShieldElement(w, element, offset+row*16, col*16, ink, paper);
		x++;
		if(*x==0)
			break;
	
		element= (*x)&7;
		ink = (*x)>>3;
		x++;
		row = (*x)&7;
		col = (*x)>>3;
	}
}
