#include <stdio.h>
#include <gtk/gtk.h>
#include <gnome.h>
#include <config.h>
#include <ctype.h>

#include "Lom.h"
#include "Render.h"

extern GtkWidget *gameview;

char WorkSpaceArea[1024];


static unsigned char Buffer[1024];
static unsigned char *PrintBufferPos=Buffer;
static unsigned char *PrintBufferStart=Buffer;
static unsigned char *PrintBuffer=Buffer;
static unsigned char *TextBuffer;
static unsigned char *Chars=FontData;
static unsigned int TextLength;
static unsigned int UpperCaseFlag;
static unsigned int MakeFirstCharUpper;



static unsigned char WhatObject;
static unsigned char WhatObjectFlag;

static unsigned char KeyReturnStatus;
static unsigned char LASTK;
static unsigned char TempVar;

static unsigned char Think_TempOne;
static unsigned char Think_TempThree;

static unsigned char ViewPoint_StartCol;
static unsigned char ViewPoint_Col;
static unsigned char ViewPoint_Width;
static unsigned char ViewPoint_Row;

static unsigned char Row, Column;
static unsigned char Window_Attr;
static unsigned char LowerWindowAttr;

static unsigned char Print_Col;
static unsigned char Print_Row;
static unsigned char Print_Mask;
static unsigned char Print_Attr;
static unsigned char Print_Ink;

static unsigned int CurrentLocation;
static unsigned int WorkingLocation;
static unsigned int DesirableLocation;
static unsigned int LocationToMoveTo;
static unsigned int LocationLookingAt;
static unsigned char TempCharacterNo;

static unsigned char CurrentlyLooking;


static unsigned char LocationArea;
static unsigned char LocDomainFlag;
static unsigned char LocationFeature;
static unsigned char LocSpecialFlag;
static unsigned char LocationObject;

static unsigned char IncRidersEnergyBy;
static unsigned char SaveCurChar= 2/*FIXME0*/;


static unsigned short CharLocation;
static unsigned char CharLookDirection;
static unsigned char CharTimeOfDay;
static unsigned char CharFirstName;
static unsigned char CharTitle;
static unsigned char CharAvailable;
static unsigned char CharGraphicType;
static unsigned char CharNoRiders;
static unsigned char CharRidersEnergyStatus;
static unsigned char CharNoWarriors;
static unsigned char CharWarriorsEnergyStatus;
static unsigned char CharBattleArea;
static unsigned char CharRidersLost;
static unsigned char CharWarriorsLost;
static unsigned char CharSlew;
static unsigned char CharRidersSlew;
static unsigned char CharWarriorsSlew;
static unsigned char CharBattleStatus;
static unsigned char CharLifeStatus;
static unsigned char CharEnergyStatus;
static unsigned char CharFightStrength;
static unsigned char CharCowardess;
static unsigned char CharRecruitingKey;
static unsigned char CharRecruitedBy;
static unsigned char CharCourageStatus;
static unsigned char LFF7A;
static unsigned char CharHideFlag;
static unsigned char CharRace;
static unsigned char CharHasAHorse;
static unsigned char CharObjectCarrying;
static unsigned char CharDeathStatus;

static unsigned char CharHereTable[32];

static unsigned char DoomDarksArmyPosInTable;
static unsigned char DoomDarks_Riders;
static unsigned char DoomDarks_Warriors;
static unsigned char FreeArmyPosInTable;
static unsigned char NoInCharHereTable;
static unsigned char CharInHereTable;
static unsigned char PrintCharacterCount;
static unsigned char CanMoveForward;
static unsigned char HowManyCharsInFrontDescribed;

static unsigned char *StartOfTokenTable = TokenData;

static unsigned char LandscapePosition;
static unsigned char Landscape_ScrAdjust;
static unsigned char Landscape_ScrAdjust1;
static short Image_XPixel;
static unsigned char Image_YPixel;
static unsigned char Image_XOffset;
static unsigned char Image_YOffset;
static unsigned char Feature_Size;
static unsigned char Landscape_XAdjust;
static unsigned char Landscape_YAdjust;
static unsigned char Landscape_XAdjustDoWhat;
static unsigned char Landscape_YAdjustDoWhat;
static unsigned char Landscape_ScrAdjustDoWhat;
static unsigned char Landscape_LeftScrDoWhat;
static unsigned char Landscape_RightScrDoWhat;
static unsigned char Landscape_LeftXAdjustDoWhat;
static unsigned char Landscape_RightXAdjustDoWhat;
static unsigned char Landscape_LeftYAdjustDoWhat;
static unsigned char Landscape_RightYAdjustDoWhat;

/*
 *	 Forward declarations
 */
 
extern void TerminatorToBuffer(void);
extern void LookingWhere(void);
extern void DisplayCharacter(int);
static void CheckLocationInFront(void);
 
/*
 *	Pull a 5 bit code out of a string.
 */
 
unsigned char GetRequiredByte(int offset5)
{
	unsigned char *ptr;
	unsigned short x;
	int bits;
	
	offset5*=5;
	
	bits=offset5;
	
	bits&=7;	/* mod 8 */
	
	offset5>>=3;
	
	/* Ok we now have the offset byte */
	ptr=StartOfTokenTable+offset5;
	
	/* Load up the next two bytes. Remember they may be misaligned! */
	x=(ptr[1]<<8)|ptr[0];
	
	x>>=bits;
	
	return x&0x1F;
}


unsigned char GetASCIIchar(int offset)
{
	unsigned char a=GetRequiredByte(offset);
	a|=0x60;
	return a;
}
	

void DecodeToken(unsigned char c)
{
	unsigned char a=0;
	int cn=c+1;
	
	int offset=0;
	int len;
	int ct=0;
	
	do
	{
		offset+=a;
		cn--;
		/* This is fun - 5 bit codes */
		a=GetRequiredByte(offset);
	}
	while(cn>0);
	
	len=a-1;
	offset+=1;
	
	while(ct<len)
	{
		*TextBuffer++=(GetRequiredByte(offset)|0x60);
		offset++;
		ct++;
	}
	TextLength+=len;
}


unsigned char DecideCase(unsigned char a)
{
	if(UpperCaseFlag)
	{
		if(!islower(a))
			return a;
		return toupper(a);
	}
	if(MakeFirstCharUpper)
	{
		MakeFirstCharUpper=0;
		if(!islower(a))
			return a;
		return toupper(a);
	}
	return a;
}


static unsigned char AttrTable[25][32];

void PrintAsciiChar(unsigned char x)
{
	int ink, paper;
	unsigned char *p;
	
	if(Print_Row>24||Print_Col>31)
	{
		printf("YOUCH in PrintAsciiChar\n");
		return;
	}
	p=&AttrTable[Print_Row][Print_Col];
	
//	*p= (*p&~Print_Mask)|(Print_Attr&Print_Mask);

	*p=Print_Attr;

	paper=(*p>>3)&7;
	ink = *p&7;
	
	
	DrawLetter(gameview, Print_Col*16, Print_Row*16, x-32, ink, paper, 
		Chars, Print_Mask);
}



void PrintWordFromBuffer(void)
{
	char *x;
	if(ViewPoint_Col+TextLength>=ViewPoint_Width)
	{
		ViewPoint_Col=ViewPoint_StartCol;
		ViewPoint_Row++;
	}
	Print_Col=ViewPoint_Col+1;
	Print_Row=ViewPoint_Row;
	
	x=WorkSpaceArea;
	
	while(TextLength)
	{
		unsigned char a=*x++;
		a=DecideCase(a);
		PrintAsciiChar(a);
		Print_Col++;
		TextLength--;
	}		
	
	ViewPoint_Col=Print_Col;
}

void PrintOutBuffer(void)
{
	unsigned char *pb=PrintBufferStart;
	unsigned char *ws;
	unsigned char *tb;
	unsigned char a;
	
	while(1)
	{
	
		TextBuffer=WorkSpaceArea;
		MakeFirstCharUpper=0;
		TextLength=0;
redo:	
		a=*pb;
		if(a==0xFF)
			return;
		switch(a)
		{
			case 0xFE:
				pb++;
				a=*pb;
				*TextBuffer++=a;
				TextLength++;
				goto redo_b;
			case 0xFC:
				MakeFirstCharUpper=1;
				pb++;
				goto redo;
			case 0xFB:
				ViewPoint_Col=ViewPoint_StartCol;
				ViewPoint_Row++;
				pb++;
				goto redo;
			default:
				DecodeToken(a);
		}

redo_b:
		pb++;
		switch(*pb)
		{
			case 0xFE:
				pb++;
				a=*pb;
				*TextBuffer++=a;
				TextLength++;
				goto redo_b;
			case 0xFD:
				pb++;
				a=*pb;
				DecodeToken(a);
				goto redo_b;
			default:
				PrintWordFromBuffer();
		}
	}
}

	
	

void FlushPrintBuffer(void)
{
	TerminatorToBuffer();
	PrintBufferPos=Buffer;
	PrintBufferStart=Buffer;
	PrintOutBuffer();
}

void A_IntoPrintBuffer(unsigned char a)
{
	*PrintBufferPos++=a;
	*PrintBufferPos=0xFF;
}

void FillPrintBuffer(unsigned char *ptr)
{
	while(*ptr!=0xFF)
	{
		A_IntoPrintBuffer(*ptr);
		ptr++;
	}
}

void BytesPrintBuffer(char *ptr)
{
	FillPrintBuffer(ptr);
}

void SetTokenToUpperCase(void)
{
	A_IntoPrintBuffer(0xFC);
}

void SetTokenToLowerCase(void)
{
	A_IntoPrintBuffer(0xFB);
}


void AddTokenWithConnect(unsigned char token)
{
	A_IntoPrintBuffer(0xFD);
	A_IntoPrintBuffer(token);
}

void AddLiteralToBuffer(unsigned char c)
{
	A_IntoPrintBuffer(0xFE);
	A_IntoPrintBuffer(c);
}

void TerminatorToBuffer(void)
{
	A_IntoPrintBuffer(0xFF);
}

void SToBuffer(void)
{
	AddLiteralToBuffer(0x73);
}

void StopToBuffer(void)
{
	AddLiteralToBuffer(0x2E);
}

void CommaToBuffer(void)
{
	AddLiteralToBuffer(0x2C);
}

void PercentToBuffer(void)
{
	AddLiteralToBuffer(0x25);
}

void AndSignToBuffer(void)
{
	AddLiteralToBuffer(0x26);
}

void PlinkToBuffer(void)
{
	AddLiteralToBuffer(0x21);
}

void HashToBuffer(void)
{
	AddLiteralToBuffer(0x23);
}

void SpaceToBuffer(void)
{
	AddLiteralToBuffer(0x20);
}

void PluralToken(unsigned char token, int plural)
{
	A_IntoPrintBuffer(token);
	if(plural)
		SToBuffer();
}

int TestFeatureForPlural(int feature)
{
	switch(feature)
	{
		case MOUNTAIN:
		case DOWNS:
		case FROZENWASTE:
		case PLAINS:
			/* Plural */
			return 1;
		case ARMY:
			if(feature+1==PLAINS)
				return 1;
			return 0;
		default:
			return 0;
	}
}

void DescribeLocation(void)
{
	int feature=LocationFeature;
	int plural;
	
	if(LocDomainFlag==0)
	{
		plural=TestFeatureForPlural(feature);
		if(feature==HENGE)
		{
			SetTokenToUpperCase();
			A_IntoPrintBuffer(LocationArea);
			AddTokenWithConnect(0x44);
			return;
		}
		if(feature==LAKE)
		{
			BytesPrintBuffer("\xFC\x4A\xFC\xFF");
			A_IntoPrintBuffer(LocationArea);
			return;
		}
		if(feature==FROZENWASTE)
		{
			BytesPrintBuffer("\x00\xFC\x51\xFC\x4B\xFF");
			SToBuffer();
			return;
		}
		if(feature==ARMY)
			feature=PLAINS;
		A_IntoPrintBuffer(0);	/* The */
		SetTokenToUpperCase();
		PluralToken(feature+0x41, plural);	/* whatever */
		A_IntoPrintBuffer(0x40);	/* of */
		if(LocationArea==0x07 || LocationArea==0x02 || LocationArea==0x39)
		{
			A_IntoPrintBuffer(0);	/* The */
		}
		SetTokenToUpperCase();
		A_IntoPrintBuffer(LocationArea);
		return;
	}
	/* Describe Feature */
	plural=TestFeatureForPlural(feature);
	if(!plural)
		A_IntoPrintBuffer(0x53);
	if(feature==ARMY)
		feature=PLAINS;
	PluralToken(0x41+feature, plural);
	BytesPrintBuffer("\x54\x00\xFC\x52\x40\xff");
	if(LocationArea==0x07 || LocationArea==0x02 || LocationArea==0x39)
	{
		A_IntoPrintBuffer(0);	/* The */
	}
	SetTokenToUpperCase();
	A_IntoPrintBuffer(LocationArea);
}

static unsigned char WhereTable[]={
	0x54,0x5D,0x54,0x5D,0x5D,0x54,0x5E,0x5D,
	0x5D,0x5F,0x54,0x54,0x5D,0x5D,0x54,0x5E
};

unsigned char *CalcMapHL(int x, int y)
{
	y--;
	y*=64;
	return MainMap+y+x;
}

void CalcMapLocation(void)
{
	unsigned char *p;
	int x=WorkingLocation&0xFF;
	int y=(WorkingLocation>>8)&0xFF;
	
	if(y==0 || x>0x3F || y>=0x3D)
	{
		LocationFeature=FROZENWASTE;
		LocationObject=0;
		LocationArea=0;
		LocDomainFlag=0;
		LocSpecialFlag=0;
		return;
	}
	p=CalcMapHL(x, y);		/* Get Primary Map */
	LocationFeature=(*p)&0x0F;
	LocationObject=((*p)>>4)&0x0F;
	p+=0xF40;		/* Second Map */
	LocationArea=(*p)&0x3F;
	if((*p&0x40)==0x40)
		LocDomainFlag=0x40;
	if((*p&0x80)==0x80)
		LocSpecialFlag=0x80;
}
		
void DescribeWhereHeIs(void)
{
	int la,ld, lf, ac;
	BytesPrintBuffer("\xFC\x55\x56\xFE\x73\xFF");
	WorkingLocation=CurrentLocation;
	CalcMapLocation();
	
	la=LocationArea;
	ld=LocDomainFlag;
	lf=LocationFeature;
	
	A_IntoPrintBuffer(WhereTable[LocationFeature]);
	DescribeLocation();
	CommaToBuffer();
	A_IntoPrintBuffer(0x5B);
	LookingWhere();
	WorkingLocation=LocationLookingAt;
	CalcMapLocation();
		
	if(LocationArea!=ac || LocDomainFlag!=ld  || LocationFeature!=lf)
	{
		A_IntoPrintBuffer(0x5C);
		DescribeLocation();
	}
	StopToBuffer();
}

struct dir_table
{
	unsigned char word, word2;
};

struct dir_table DirectionTable[]=
{
	{0x57,0x00},
	{0x57,0x59},
	{0x59,0x00},
	{0x58,0x59},
	{0x58,0x00},
	{0x58,0x5A},
	{0x5A,0x00},
	{0x57,0x5A}
};

void LookingWhere(void)
{
	int a=CurrentlyLooking;
	SetTokenToUpperCase();
	A_IntoPrintBuffer(DirectionTable[a].word);
	if(DirectionTable[a].word2)
		AddTokenWithConnect(DirectionTable[a].word2);
}


	
void PrintTimeStatus(int time)
{
	int n;
	if(time<1)
	{
		BytesPrintBuffer("\x6F\x70\x71\xFF");
		return;
	}
	n=time&1;
	time>>=1;
	if(time==8)
	{
		BytesPrintBuffer("\x6F\x70\x3D\xFF");
		return;
	}
	if(n)
	{
		time++;
		BytesPrintBuffer("\x60\x61zxFF");
	}
	A_IntoPrintBuffer(0x61+time);
	PluralToken(0x52, time==1?0:1);
	BytesPrintBuffer("\x40\x00\x6E\xFF");
	PluralToken(0x6D, time==1?0:1);
}	


void ClearWindow(int start, int width, int end, int unused)
{
	while(start<=end)
	{
		int r;
		for(r=0;r<width;r++)
		{
			Print_Col=r;
			Print_Row=start;
			PrintAsciiChar(' ');
		}
		start++;
	}
}

void DefineViewPoint(int a, int b, int c, int d, int e, int f)
{
	ViewPoint_Col=a;
	ViewPoint_Row=b;
	ViewPoint_StartCol=c;
	ViewPoint_Width=d;
	Print_Attr=e;
	Print_Mask=f;
	UpperCaseFlag=0;
}


void DoWindowFive(void)
{
	Print_Attr=0x03;
	Print_Mask=0x00;
	ClearWindow(0x00, 0x20, 0x18, 0x03);
	DefineViewPoint(0x00, 0x00, 0x00, 0x1F, 0x03, 0x00);
}

void DoWindowOne(void)
{
	Print_Mask=0x00;
	Print_Attr=0x38;
	ClearWindow(0x00,0x20, 0x18, 0x07);
}


void DoWindowThree(void)
{
	Print_Mask=0xFF;
	Print_Attr=0x79;
	ClearWindow(0x02, 0x18, 0x08, 0x79);
}

void DoWindowFour(void)
{
	Print_Mask=0xFF;
	Print_Attr=0x49;
	ClearWindow(0x08, 0x20, 0x0E, 0x49);
	Print_Attr=LowerWindowAttr;
	Print_Mask=0;
	ClearWindow(0x0E,0x20, 0x18, 0x00);
}

void DoWindowTwo(void)
{
	Print_Mask=0xFF;
	Print_Attr=0x79;
	ClearWindow(0x00, 0x20, 0x08, 0x04);
	DoWindowFour();
}

void ClearAllScreen(void)
{
	DoWindowOne();
	DefineViewPoint(0x00, 0x05, 0x00, 0x1F, 0x3A, 0x00);
}

void FirstNameToBuffer(void)
{
	SetTokenToUpperCase();
	A_IntoPrintBuffer(CharFirstName);
}

void FirstName_The_What(unsigned char t)
{
	FirstNameToBuffer();
	A_IntoPrintBuffer(0);
	SetTokenToUpperCase();
	A_IntoPrintBuffer(t);
}

void FullCharTitle(void)
{
	unsigned char a=CharTitle;
	switch(a)
	{
		case 0:
			FirstName_The_What(0x7E);
			return;
		case 1:
			FirstNameToBuffer();
			return;
		case 2:
			FirstName_The_What(0x7A);
			return;
		case 3:
			FirstName_The_What(0x7B);
			return;
		case 4:
			FirstName_The_What(0x7D);
			AddTokenWithConnect(0x79);
			return;
		case 5:
			FirstName_The_What(0x7C);
			return;
		case 10:
			A_IntoPrintBuffer(0x00);
			FirstNameToBuffer();
			A_IntoPrintBuffer(0x40);
			FirstNameToBuffer();
			return;
	}
	if(a<10)
	{
		BytesPrintBuffer("\x00\xFC\x79\x40\xFF");
		FirstNameToBuffer();
		return;
	}	
	else
	{
		BytesPrintBuffer("\xFC\x79\xFF");
		FirstNameToBuffer();
		return;
	}	
}


static unsigned char LandscapeTable[]={
	0x05,0x04,0x56,0x00,0x40,0x07,
	0x04,0x05,0x72,0x00,0x40,0x07,
	0x06,0x02,0x29,0x00,0x40,0x07,
	0x06,0x01,0x15,0x00,0x40,0x07,
	0x06,0xFF,0xEB,0xFF,0x40,0x07,
	0x06,0x00,0x00,0x00,0x40,0x07,
	0x05,0x03,0x45,0x00,0x3F,0x07,
	0x03,0x05,0x83,0x00,0x3F,0x07,
	0x04,0x04,0x64,0x00,0x3F,0x07,
	0x05,0x02,0x30,0x00,0x3F,0x06,
	0x05,0x01,0x19,0x00,0x3F,0x06,
	0x05,0xFF,0xE7,0xFF,0x3F,0x06,
	0x05,0x00,0x00,0x00,0x3E,0x06,
	0x04,0x03,0x52,0x00,0x3E,0x06,
	0x03,0x04,0x76,0x00,0x3E,0x06,
	0x04,0x02,0x3B,0x00,0x3E,0x06,
	0x03,0x03,0x64,0x00,0x3D,0x05,
	0x04,0x01,0x1F,0x00,0x3D,0x05,
	0x04,0xFF,0xE1,0xFF,0x3D,0x05,
	0x04,0x00,0x00,0x00,0x3C,0x05,
	0x03,0x02,0x4B,0x00,0x3B,0x05,
	0x02,0x03,0x7D,0x00,0x3B,0x05,
	0x03,0x01,0x29,0x00,0x3A,0x04,
	0x03,0xFF,0xD7,0xFF,0x3A,0x04,
	0x03,0x00,0x00,0x00,0x39,0x04,
	0x02,0x02,0x64,0x00,0x39,0x04,
	0x02,0x01,0x3B,0x00,0x35,0x03,
	0x01,0x02,0x8D,0x00,0x35,0x03,
	0x02,0x00,0x00,0x00,0x33,0x02,
	0x01,0x01,0x64,0x00,0x2B,0x01,
	0x01,0x00,0x00,0x00,0x20,0x00
};


static unsigned char WalkMapY(unsigned char c, int v)
{
	switch(v)
	{
		case 0:
			c+=Landscape_YAdjust;
			break;
		case 1:	
			c-=Landscape_YAdjust;
			break;
		case 2:
			c+=Landscape_XAdjust;
			break;
		default:
			c-=Landscape_XAdjust;
			break;
	}
	return c;
}

static unsigned char WalkMapX(unsigned char c, int v)
{
	switch(v)
	{
		case 0:
			c+=Landscape_YAdjust;
			break;
		case 1:	
			c-=Landscape_YAdjust;
			break;
		case 2:
			c+=Landscape_XAdjust;
			break;
		default:
			c-=Landscape_XAdjust;
			break;
	}
	return c;
}

void DrawGraphicView(void)
{
	int a=LandscapePosition*6;
	unsigned char *p=LandscapeTable+a;
	int lsa;
	
	Landscape_YAdjust=*p++;
	Landscape_XAdjust=*p++;
	Landscape_ScrAdjust=*p++;
	Landscape_ScrAdjust1=*p++;
	Image_YPixel=*p++;
	Feature_Size=*p;
	
//	printf("XAdjust=%d YAdjust=%d XDW=%d YDW=%d\n",
//		Landscape_XAdjust, Landscape_YAdjust,
//		Landscape_XAdjustDoWhat, Landscape_YAdjustDoWhat);
	WorkingLocation=WalkMapX(CurrentLocation&0xFF, Landscape_XAdjustDoWhat);
	WorkingLocation|=(WalkMapY(CurrentLocation>>8, Landscape_YAdjustDoWhat))<<8;
	CalcMapLocation();
	
//	printf("Looking at (%d,%d)\n", WorkingLocation&0xFF, WorkingLocation>>8);
	
	lsa=Landscape_ScrAdjust+(Landscape_ScrAdjust1<<8);
	
	switch(Landscape_ScrAdjustDoWhat)
	{	
		case 0:
			Image_XPixel=lsa+0x140;
			break;
		case 1:
			Image_XPixel=0x140-lsa;
			break;
		case 2:
			Image_XPixel=lsa+0x140-0x64;
			break;
		default:
			Image_XPixel=(0x140-lsa)+0x64;
	}
//	printf("XPixel=%d\n", Image_XPixel);
	Image_XPixel-=256;
	if(LocationFeature!=15)
		DrawFeature(gameview, CharTimeOfDay, LocationFeature, Feature_Size, Image_XPixel*2, (192-Image_YPixel)*2);
}

unsigned char GraphicLookTable[]={
	0x03,0x02,0x00,0x00,0x02,0x03,0x01,0x01,0x03
};

unsigned char GraphicLookTable2[]={
	0x01,0x01,0x03,0x02,0x00,0x00,0x02,0x03,0x01
};


void DrawGraphicVision(void)
{
	unsigned char *p=GraphicLookTable+CurrentlyLooking;
	Landscape_LeftScrDoWhat=1;
	Landscape_RightScrDoWhat=0;

	if(CurrentlyLooking&1)
	{
		Landscape_LeftScrDoWhat=2;
		Landscape_RightScrDoWhat=3;
	}
	
	DrawHorizon(gameview, CharTimeOfDay);

	p=GraphicLookTable+CurrentlyLooking;
	Landscape_LeftXAdjustDoWhat=*p++;
	Landscape_RightXAdjustDoWhat=*p++;
	p=GraphicLookTable2+CurrentlyLooking;
	Landscape_LeftYAdjustDoWhat=*p++;
	Landscape_RightYAdjustDoWhat=*p++;
	
	LandscapePosition=0;
	
	do
	{
		Landscape_ScrAdjustDoWhat=Landscape_LeftScrDoWhat;
		Landscape_XAdjustDoWhat=Landscape_LeftXAdjustDoWhat;
		Landscape_YAdjustDoWhat=Landscape_LeftYAdjustDoWhat;
		DrawGraphicView();
		Landscape_ScrAdjustDoWhat=Landscape_RightScrDoWhat;
		Landscape_XAdjustDoWhat=Landscape_RightXAdjustDoWhat;
		Landscape_YAdjustDoWhat=Landscape_RightYAdjustDoWhat;
		DrawGraphicView();
		LandscapePosition++;
	}
	while(LandscapePosition!=0x1F);
}

void DrawMainScreen(void)
{
	unsigned char attr;
	
	if(CharTimeOfDay==0)
		attr=0x40;
	else
	{
		attr=0x7F;
		printf("Day\n");
	}
	LowerWindowAttr=attr;
	DoWindowTwo();
	DrawShield(gameview, TempCharacterNo);
	DefineViewPoint(0x00, 0x01, 0x01, 0x17, 0x71, 0xFF);
	UpperCaseFlag=1;
	FullCharTitle();
	FlushPrintBuffer();
	DefineViewPoint(0x01, 0x02, 0x01, 0x17, 0x69, 0xFF);
	DescribeWhereHeIs();
	FlushPrintBuffer();
	DrawGraphicVision();
	//if(CharTimeOfDay==0)
	//	ClearAttributesNight();
	//else
	//  	ClearAttributesDay();
}

unsigned char *CalcCharTablePos(int c)
{
	return CharTable + 32*c;
}

void SaveCharDetails(void)
{
	int c=TempCharacterNo;
	unsigned char *p=CalcCharTablePos(c);
	
//	printf("Saving %d\n", c);
	p[0]=CharLocation&0xFF;
	p[1]=CharLocation>>8;
	p[2]=CharLookDirection;
	p[3]=CharTimeOfDay;
	p[4]=CharFirstName;
	p[5]=CharTitle;
	p[6]=CharAvailable;
	p[7]=CharGraphicType;
	p[8]=CharNoRiders;
	p[9]=CharRidersEnergyStatus;
	p[10]=CharNoWarriors;
	p[11]=CharWarriorsEnergyStatus;
	p[12]=CharBattleArea;
	p[13]=CharRidersLost;
	p[14]=CharWarriorsLost;
	p[15]=CharSlew;
	p[16]=CharRidersSlew;
	p[17]=CharWarriorsSlew;
	p[18]=CharBattleStatus;
	p[19]=CharLifeStatus;
	p[20]=CharEnergyStatus;
	p[21]=CharFightStrength;
	p[22]=CharCowardess;
	p[23]=CharRecruitingKey;
	p[24]=CharRecruitedBy;
	p[25]=CharCourageStatus;
	p[26]=LFF7A;
	p[27]=CharHideFlag;
	p[28]=CharRace;
	p[29]=CharHasAHorse;
	p[30]=CharObjectCarrying;
	p[31]=CharDeathStatus;
}

void CopyCharDetails(int c)
{
	unsigned char *p=CalcCharTablePos(c);
	TempCharacterNo=c;
//	printf("Retrieving %d\n", c);
	CharLocation=p[0]+(p[1]<<8);
//	printf("Char Location =%x\n", CharLocation);
	CharLookDirection=p[2];
	CharTimeOfDay=p[3];
	CharFirstName=p[4];
	CharTitle=p[5];
	CharAvailable=p[6];
	CharGraphicType=p[7];
	CharNoRiders=p[8];
	CharRidersEnergyStatus=p[9];
	CharNoWarriors=p[10];
	CharWarriorsEnergyStatus=p[11];
	CharBattleArea=p[12];
	CharRidersLost=p[13];
	CharWarriorsLost=p[14];
	CharSlew=p[15];
	CharRidersSlew=p[16];
	CharWarriorsSlew=p[27];
	CharBattleStatus=p[18];
	CharLifeStatus=p[19];
	CharEnergyStatus=p[20];
	CharFightStrength=p[21];
	CharCowardess=p[22];
	CharRecruitingKey=p[23];
	CharRecruitedBy=p[24];
	CharCourageStatus=p[25];
	LFF7A=p[26];
	CharHideFlag=p[27];
	CharRace=p[28];
	CharHasAHorse=p[29];
	CharObjectCarrying=p[30];
	CharDeathStatus=p[31];
}


void UpdateCharsVars(void)
{
	CopyCharDetails(SaveCurChar);
	CurrentLocation=CharLocation;
	CurrentlyLooking=CharLookDirection;
}

struct direction_walk
{
	int xadjust, yadjust;
};

struct direction_walk DirectionLookTable[]={
	{ 0,-1},
	{ 1,-1},
	{ 1, 0},
	{ 1, 1},
	{ 0, 1},
	{-1, 1},
	{-1, 0},
	{-1,-1}
};



void FindLookingTowards(void)
{
	struct direction_walk *d=&DirectionLookTable[CurrentlyLooking];
	int lfc = 0;
	
	WorkingLocation=CurrentLocation;
	
//	printf("CurrentLocation=%x\n", CurrentLocation);
	
	do
	{
		/* Y */
		WorkingLocation+=256*d->yadjust;
		/* X */
		WorkingLocation+=d->xadjust;
		if(lfc==0)
		{
			DesirableLocation=WorkingLocation;
//			printf("Desirable=%x\n", DesirableLocation);
		}
		CalcMapLocation();
		if(LocationFeature!=PLAINS)
			break;
		lfc++;
	}
	while(lfc<3);
	
	LocationLookingAt=WorkingLocation;
}

void GetFromCharHereTable(void)
{
	CopyCharDetails(CharHereTable[CharInHereTable]);
}

void WorkOutLocationDetails(void)
{
	int a;
	int cloc;
	WorkingLocation=CurrentLocation;
	CalcMapLocation();
	if(LocationFeature==MOUNTAIN)
		IncRidersEnergyBy=0x40;
	else
		IncRidersEnergyBy=0x20;
#if 0		
	PosInCharHereTable=CharHereTable;
	StartOfDoomDarksTable=WorkSpaceArea;
	StartOfFreeTable=WorkSpaceArea+128;
	DoomDarks_Warriors=0;
	DoomDarks_Riders=0;
	FreeArmyHere=0;
	DoomDarmsArmyHere=0;
	NoInCharHereTable=0;
	TempCharacterNo=0;
	FreeArmyPosInTable=0;
	Army_Details=0;
	DoomDarksElite=0;
	CalculateIceFear();
	
	cloc=WorkingLocation;
	
	do
	{
		GetArmyDetails();
		if(HowManyGuardsThePlace)
		{
			if(ArmyLocation==cloc)
				AddArmyToBattleTable();
		}
		Army_Details++;
	}
	while(Army_Details<0x66);
	
	do
	{
		GetArmy_DoomDarksElite();
		if(DoomDarksElite_Total)
		{
			if(cloc==DoomDarksElite_Location)
				AddArmyToDoomDarksBattleTable();
		}
		Army_DoomDarksElite++;
	}
	while(Army_DoomDarksElite<128);
	
	do
	{
		CopyCharDetails();
	
		if(CharLifeStatus!=0 && CharHideFlag!=0 && CharLocation == cloc)
			CharAddToBattleTable();
		TempCharacterNumber++;
	}
	while(TempCharacterNumber<0x20);
	
	LastDoomDarksArmyInTable=DoomDarksArmyPosInTable;
	LastFreeArmyInTable=FreeArmyPosInTable;
	NoOfFreeArmiesAndChars=LastFreeArmyInTable+NoInCharHereTable;
	TotalNoOfArmiesHere=NoOfFreeArmiesAndChars+LastDoomDarksArmyInTable;
#endif	
}

void GetLatestCharInfo(void)
{
	UpdateCharsVars();
	FindLookingTowards();
	WorkOutLocationDetails();
	UpdateCharsVars();
}


static int directions;


void DrawMainFeature(void)
{
	DoWindowOne();
	if(LocationFeature!=15)
		DrawFeature(gameview, 1, LocationFeature, 0,
			0x80*2, (192-0x60)*2);
	DefineViewPoint(0xFF,0,0,0x1f, 0x3A, 0x00);
	Print_Ink=0;
	SetTokenToUpperCase();
	FullCharTitle();
	FlushPrintBuffer();
	Column=0x09;
	Row=0x0A;
	Window_Attr=0x3F;
	DisplayCharacter(CharGraphicType);
	DefineViewPoint(0x00,0x0B, 0x00, 0x1F, 0x3A, 0x00);
}

void DisplayThinkAgain(void)
{
	BytesPrintBuffer("\xFB\xFC\x55\xFF");
	FlushPrintBuffer();
	Print_Attr=0x3C;
	A_IntoPrintBuffer(0xC9);
	FlushPrintBuffer();
	Print_Attr=0x3A;
	BytesPrintBuffer("\x94\xFE\x2E\xFE\x2E\xFE\x2E\xFE\x2E\xFF");
	FlushPrintBuffer();
}

void WeAreLooking(void)
{
	if(Think_TempThree==1)
		SetTokenToUpperCase();
	BytesPrintBuffer("\xFC\x5C\x00\xFF");
	LookingWhere();
	CommaToBuffer();
}

void DescribeWhatCharSees(void)
{
	WeAreLooking();
//	DisplayArmyStatus();
}

static char LE485[]={0x55,0xC7,0x00,0xFF};					// 'He Slew The'
static char LE489[]={0xFC,0x4A,0xFC,0x04,0xFF};                  		// 'Lake Mirrow'
static char LE48E[]={0xEA,0xFF};                                  		//  'Crown'
static char LE490[]={0xFC,0x2D,0x00,0xFC,0x7B,0xFF}; 				// 'Lorgrim The Wise'
static char LE496[]={0x8D,0xA4,0xF0,0xFF};                           		// 'You Must Seek'
static char LE4AE[]={0xFC,0x55,0x8A,0xE3,0xF9,0xFF};                  		// 'He Has With Him'
static char LE4B4[]={0xFE,0x2E,0xFC,0x0,0xFC,0x9B,0xFC,0xA9,0x70,0xFF};		// '. The Ice Fear Is'
static char LE4BE[]={0x70,0xEF,0xFE,0x2E,0xFF};                        		// 'Is Hidden.'
static char LE4C3[]={0xAE,0xAD,0x87,0x55,0xA4,0xF7,0xA8,0xEE,0xFF};    		// 'Are Abroad And He Must Fight Or Hide'
static char LE4CC[]={0x00,0xFC,0xE8,0x40,0xFC,0xE2,0xDE,               		// 'The Waters Of Life Which'
			0xE0,0xF9,0xE3,0xE1,0xFF};                       	// 'Fill Him With Vigour'
static char LE4D8[]={0xB0,0xFF};                                                // 'Nothing'
static char LE4DA[]={0xF8,0xFF};                                               	// 'Wolves'
static char LE4DC[]={0x7D,0xFE,0x73,0xFF};                                     	// 'Dragons'
static char LE4E0[]={0x9B,0x9C,0xFE,0x73,0xFF};                                	// 'Ice Trolls'
static char LE4E5[]={0x7C,0xFF};                                               	// 'Skulkrin'
static char LE4E7[]={0x9D,0x99,0xFE,0x73,0xFF};                                	// 'Wild Horses'
static char LE4EC[]={0xDC,0x87,0x70,0xDD,0xFF};                                	// 'Shelter And Is Refreshed'
static char LE4F1[]={0xD9,0xFE,0x2E,0xFC,0x53,0xDA,0xDB,0xFE,0x2C,0xFF};       	// 'Guidance. A Voice Calls,'
static char LE4FB[]={0x00,0xFC,0x1A,0x40,0xFC,0x0B,0xDE,0xDF,0xF9,0x40,		// 'The Shadows Of Death Which Drain Him Of'
			0xE1,0xFF};                                             // 'Vigour'
static char LE507[]={0x00,0xFC,0xE4,0x40,0x00,0xFC,0xA0,0xDE,0xE5,0x0B,0x5C,	// 'The Hand Of The Dark Which Brings Death To'
			0x00,0x6E,0xFF};                                      	// 'The Day'
static char LE515[]={0x00,0xFC,0xE9,0x40,0xFC,0x32,0xDE,0xE5,0xA7,0xA2,0xFF}; 	// 'The Cup Of Dreams Which Brings New Welcome'
static char LE520[]={0x00,0xE6,0xFC,0x9A,0xFD,0xE7,0xFF};                     	// 'The Sword Wolfslayer'
static char LE527[]={0x00,0xE6,0xFC,0x7D,0xFD,0xE7,0xFF};                     	// 'The Sword Dragonslayer'
static char LE52E[]={0x00,0xFC,0x03,0xFC,0xFA,0xFF};                          	// 'The Moon Ring'
static char LE534[]={0x00,0xFC,0x9B,0xFC,0xEA,0xFF};                          	// 'The Ice Crown'
static char LE53A[]={0xFC,0x76,0x00,0xFC,0x7C,0xFF};                          	// 'Fawkrin The Skulkrin'
static char LE540[]={0xFC,0x77,0x00,0xFC,0x7D,0xFD,0x79,0xFF};                	// 'Farflame The Dragonlord'
static char LE548[]={0xFC,0x55,0x8A,0xAF,0xFF};               			//  'He Has Found'


static unsigned char *ObjectStrings[]={
	LE4D8,LE4DA,LE4DC,LE4E0,
	LE4E5,LE4E7,LE4EC,LE4F1,
	LE4FB,LE4CC,LE507,LE515,
	LE520,LE527,LE534,LE52E,
	LE53A,LE540,LE489,LE490
};

void DescribeAnObject(int o)
{
	FillPrintBuffer(ObjectStrings[o]);
}

void WhoKilledHim(void)
{
	SetTokenToUpperCase();
	if(CharDeathStatus==0)
	{
		BytesPrintBuffer("\x55\x90\xF1\x54\xC3\x2E\xFF");
//		DescribeBattle();
		return;
	}
	DescribeAnObject(CharDeathStatus);
	BytesPrintBuffer("xxC7\xF9\xFE\x2E\xFF");
}


void DescribeCharCondition(void)
{
	SetTokenToUpperCase();
	PrintTimeStatus(CharTimeOfDay);
	A_IntoPrintBuffer(0x87);
	CopyCharDetails(SaveCurChar);
	FirstNameToBuffer();
	A_IntoPrintBuffer(0x70);
//	ReportCharStatus(CharEnergyStatus);
	FillPrintBuffer(LE4B4);
//	DescribeIceFear();
	StopToBuffer();
	FirstNameToBuffer();
	A_IntoPrintBuffer(0x70);
//	DisplayCharCourage();
	StopToBuffer();
	if(CharObjectCarrying==0)
		return;
	FillPrintBuffer(LE4AE);
	DescribeAnObject(CharObjectCarrying);
	StopToBuffer();
}

void HeKilledWhatHow(int obj)
{
	FillPrintBuffer(LE485);
	DescribeAnObject(obj);
	if(CharObjectCarrying < ICECROWN && CharObjectCarrying>= WOLFSLAYER)
	{
		A_IntoPrintBuffer(0xE3);
		DescribeAnObject(CharObjectCarrying);
	}
	StopToBuffer();
	DescribeCharCondition();
}
			
void CheckThings(void)
{
	if(CharHideFlag)
	{
		FirstNameToBuffer();
		FillPrintBuffer(LE4BE);
	}
	SetTokenToUpperCase();
	if(WhatObject!=NOOBJECTATALL)
	{
		if(WhatObject>=SHELTER)
		{
			if(WhatObject>=FAWKRIN)
			{
				DescribeCharCondition();
				return;
			}
		}
	}
	FillPrintBuffer(LE548);
	DescribeAnObject(WhatObject);
	if(WhatObject!=GUIDANCE)
	{
		StopToBuffer();
		DescribeCharCondition();
		return;
	}
	PercentToBuffer();
	if(WhatObjectFlag<4)
	{
		DescribeAnObject(WhatObjectFlag+0x10);
		BytesPrintBuffer("\xED\xEB\x00\xFC\x9B\xFC\xEA\xFF");
		StopToBuffer();
		AndSignToBuffer();
		SetTokenToLowerCase();
		DescribeCharCondition();
		return;
	}
	CopyCharDetails(WhatObjectFlag);
	WorkingLocation=CharLocation;
	CalcMapLocation();
	BytesPrintBuffer("\xFC\x5B\xB6\xFF");
	FullCharTitle();
	CommaToBuffer();
	FillPrintBuffer(LE496);
	DescribeLocation();
	StopToBuffer();
	SetTokenToLowerCase();
	DescribeCharCondition();
}
			
void DisplayCharThink(void)
{
	if(KeyReturnStatus!=2)
	{
rerun_2:	
		HowManyCharsInFrontDescribed=0;
		Think_TempOne=0;
		Think_TempThree=0;
		KeyReturnStatus=2;
	}
rerun:
	GetLatestCharInfo();
	if(CharLifeStatus==0)
	{
		WhoKilledHim();
		return;
	}
	if(Think_TempOne==0)
	{
		Think_TempOne=1;
		CheckThings();	/* LEC8D */		
	}
	if(Think_TempOne==1)
	{
		Think_TempOne=2;
		if(CharBattleStatus!=0xFF)
		{
//			DescribeBattle();
			return;
		}
	}
	if(Think_TempOne==2)
	{
		Think_TempThree++;
		if(Think_TempThree!=1)
		{
			CheckLocationInFront();
			Think_TempOne=3;
		}
		if(LocationFeature==CITADEL || LocationFeature==KEEP || DoomDarksArmyPosInTable!=0 )
		{
			WeAreLooking();
//			DisplayArmiesHere();
			return;
		}
		goto rerun;
	}
	if(Think_TempThree!=1)
		CheckLocationInFront();
	if(HowManyCharsInFrontDescribed < NoInCharHereTable)
	{
		HowManyCharsInFrontDescribed=CharInHereTable+1;
		GetFromCharHereTable();
		DescribeWhatCharSees();
		return;
	}
	if(Think_TempThree==1)
		goto rerun_2;
	Think_TempThree--;
	HowManyCharsInFrontDescribed=0;
	goto rerun;
}

	
void Think(void)
{
	GetLatestCharInfo();
//	CalcCharsCourage();
	TempVar=CharTimeOfDay;
	DrawMainFeature();
	DisplayCharThink();
	DisplayThinkAgain();
	LASTK=0;
	directions=0;
}

void DisplayCharacter(int ch)
{
	int i,x;
	unsigned char *p=Chars;
	struct character_map *c;
	unsigned char *cp;
	unsigned char *ap;
	Chars=CharFont;

	Print_Mask=0;
	c=&CharMap[ch];
	
//	Window_Depth=c->depth;
//	Window_Width=c->width;
	Print_Row=Row-c->depth;
	
	cp=c->data;
	ap=c->attr;
	
	printf("Attr Window = %x", Window_Attr);
	printf("Print_Ink = %x", Print_Ink);
	
	for(i=0; i< c->depth;i++)
	{
		Print_Col=Column;
		for(x=0;x<c->width; x++)
		{
			if(*cp!=0)
			{
				unsigned char a;
				a=*ap&Window_Attr;
				a|=Print_Ink;
				Print_Attr=a;
				PrintAsciiChar(*cp+32);
			}
			cp++;
			ap++;
			Print_Col++;
		}
		Print_Row++;
	}
	Chars=p;
}

static unsigned char PrintOffsetTable[]={
	0x0C, 0x14, 0x10, 0x04, 0x08, 0x18, 0x0, 0x1C
};

void PrintCharacter(int ch, int num)
{
	while(num--)
	{
		Column=PrintOffsetTable[PrintCharacterCount];
		if(++PrintCharacterCount>8)
			return;
		DisplayCharacter(ch);		
	}
}


static unsigned char ObjectGraphic[]={
	0x05, 0x06, 0x07, 0x0C, 0x0D
};

static void CheckLocationInFront(void)
{
	CurrentLocation=DesirableLocation;
	WorkOutLocationDetails();
}

void PrintWhoEversInFront(void)
{
	int ch=0;
	int sym;
	
	Row=0x18;
	Window_Attr=0x7F;
	Print_Ink=0;
	Print_Mask=0;
	PrintCharacterCount=0;
	if(CharTimeOfDay==0)
	{
		Window_Attr=0x40;	
		Print_Ink++;
	}
//	printf("Desirable Location =%x\n", DesirableLocation);
	LocationToMoveTo=DesirableLocation;
	CheckLocationInFront();
	if(LocationFeature==FROZENWASTE)
		ch=1;
	if(FreeArmyPosInTable>=0x1D)
		ch=1;
	if(DoomDarksArmyPosInTable)
		ch|=DoomDarksArmyPosInTable;
	CanMoveForward=ch?0:1;
	if(NoInCharHereTable!=0)
	{
		CharInHereTable=0;
		do
		{
			GetFromCharHereTable();
			PrintCharacter(CharGraphicType,1);
			CharInHereTable++;
		}
		while(CharInHereTable<NoInCharHereTable);
	}
	if(DoomDarks_Riders)
	{
		PrintCharacter(2,8);
		return;
	}
	if(DoomDarks_Warriors)
	{
		PrintCharacter(9,8);
		return;
	}
	if(LocationObject==0 || LocationObject>6)
		return;
	
	sym=ObjectGraphic[LocationObject];
	if(sym==6)
		PrintCharacter(sym, 2);
	else
		PrintCharacter(sym, 4);
}
		
		
void MainGameLoopInstance(int state)
{
	GetLatestCharInfo();
	if(CharLifeStatus==0)
	{
		Think();
		return;
	}
	DrawMainScreen();
	PrintWhoEversInFront();
	GetLatestCharInfo();
	KeyReturnStatus=1;
	LASTK=1;
	directions=1;
}

void SaveChoice(int c)
{
	int tmp=SaveCurChar;
	SaveCurChar=c;
	GetLatestCharInfo();
	if(CharAvailable!=1)
	{
		printf("Dead %d\n", CharAvailable);
		SaveCurChar=tmp;
	}
	MainGameLoopInstance(0);
}
	
void ChooseLuxor(void)
{
	SaveChoice(0);
}

void ChooseMorkin(void)
{
	SaveChoice(1);
}

void ChooseCorleth(void)
{
	SaveChoice(2);
}

void ChooseRorthron(void)
{
	SaveChoice(3);
}


void MoveForward(void)
{
	int drain;
#if 0	
	printf("CharTimeOfDay=%d LifeStatus=%d EnergyStats=%d CMF=%d\n", CharTimeOfDay,
		CharLifeStatus, CharEnergyStatus, CanMoveForward);
	if(CharLifeStatus==0 || CanMoveForward==0 || CharEnergyStatus==0
		|| CharTimeOfDay==0)
	{
		Think();
		return;
	}
	if(CharTimeOfDay!=0x10)		/* Dawn ? */
	{
//		if(DoomDarksArmyPosInTable!=0)
//		{
//			Think();
//			return;
//		}
	}
	if(CharHideFlag!=0)
	{
		printf("Hiding\n");
//		Choose();
		return;
	}
	/* Someone to fight */
	if(LocationObject!=0 && LocationObject <6)
	{
		printf("Beastie %d\n", LocationObject);
//		Choose();
		return;
	}
#endif	
	CharLocation=LocationToMoveTo;
	SaveCharDetails();
//	SetResetCharsArmy();
	CurrentLocation=LocationToMoveTo;
//	SetResetCharsArmy();
	UpdateCharsVars();
	
	drain=2;
	if(CurrentlyLooking&1)
		drain++;	/* diagonal is further */
	if(CharHasAHorse==0)
		drain*=2;
	switch(LocationFeature)
	{
		case DOWNS:
			drain++;
			break;
		case MOUNTAIN:
			drain+=4;
			break;
		case FOREST:
			if(CharRace!=FEY)
				drain+=3;
			break;
	}
	if(TempCharacterNo==0x1F)	/* Farflame */
		drain=1;		/* Going by air rules ;) */

	if(CharTimeOfDay>=drain)
		CharTimeOfDay-=drain;
	else
		CharTimeOfDay=0;
		
	if(CharEnergyStatus>=drain)
		CharEnergyStatus-=drain;
	else
		CharEnergyStatus=0;
		
	if(CharRidersEnergyStatus>=drain)
		CharRidersEnergyStatus-=drain;
	else
		CharRidersEnergyStatus=0;
		
	if(CharWarriorsEnergyStatus>=drain)
		CharWarriorsEnergyStatus-=drain;
	else
		CharWarriorsEnergyStatus=0;
		
	SaveCharDetails();
	MainGameLoopInstance(0);
}

static void SaveDir(int dir)
{
	CharLookDirection=dir;
	SaveCharDetails();
	MainGameLoopInstance(0);
}

void Keyboard(unsigned char key)
{

	if(key=='-' && directions)
	{
		SaveDir((CharLookDirection-1)&7);
		return;
	}
	if(key=='=' && directions)
	{
		SaveDir((CharLookDirection+1)&7);
		return;
	}
	switch(key)
	{
		case '1':
		case '2':
		case '3':
		case '4':
		case '5':
		case '6':
		case '7':
		case '8':
			if(directions)
			{
				key-='1';
//				key=SwapKeys(key);
				if(CurrentlyLooking!=key)
				{
					CharLookDirection=key;
					SaveCharDetails();
					MainGameLoopInstance(0);
				}
			}
			return;
		case 'q':
			MoveForward();
			return;
		case 'e':
			MainGameLoopInstance(0);
			return;
		case 'r':
			Think();
			return;
		case 't':
//			Choose();
			return;
		case 'u':
//			Night();
			return;
		case 's':
//			SaveGameToTape();
			return;
		case 'd':
//			LoadGameFromTape();
			return;
//		case 'z':
//			CheckCharSelect();
//			CopyScreen();
//			ResetLASTK();
//			return;
		case 'm':
//			Select();
			return;
		case 'c':
			ChooseLuxor();
			return;
		case 'v':
			ChooseMorkin();
			return;
		case 'b':
			ChooseCorleth();
			return;
		case 'n':
			ChooseRorthron();
			return;
	}
}